Create a file object and retrieve the file upload URL - Fabric

Create a file object and retrieve the file upload URL

cURL

curl --request POST \
  --url https://api.fabric.inc/v3/catalog-connector-files \
  --header 'Authorization: Bearer <token>' \
  --header 'Content-Type: application/json' \
  --header 'x-fabric-tenant-id: <x-fabric-tenant-id>' \
  --data '\n{\n  "type": "CATALOG_CONN_ITEM_VARIANT_IMPORT",\n  "name": "bulk_import_123345677788999.csv",\n  "locale": "en-US",\n  "formatType": "jsonl"\n}\n'```

### Python

```python
import requests

url = "https://api.fabric.inc/v3/catalog-connector-files"

payload = {
    "type": "CATALOG_CONN_ITEM_VARIANT_IMPORT",
    "name": "bulk_import_123345677788999.csv",
    "locale": "en-US",
    "formatType": "jsonl"
}
h

headers = {
    "x-fabric-tenant-id": "<x-fabric-tenant-id>",
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.text)

JavaScript

const options = {
  method: 'POST',
  headers: {
    'x-fabric-tenant-id': '<x-fabric-tenant-id>',
    Authorization: 'Bearer <token>',
    'Content-Type': 'application/json'
  },
  body: JSON.stringify({
    type: 'CATALOG_CONN_ITEM_VARIANT_IMPORT',
    name: 'bulk_import_123345677788999.csv',
    locale: 'en-US',
    formatType: 'jsonl'
  })
};

fetch('https://api.fabric.inc/v3/catalog-connector-files', options)
  .then(res => res.json())
  .then(res => console.log(res))
  .catch(err => console.error(err));

PHP

$curl = curl_init();

curl_setopt_array($curl, [
  CURLOPT_URL => "https://api.fabric.inc/v3/catalog-connector-files",
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => "",
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 30,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => "POST",
  CURLOPT_POSTFIELDS => json_encode([
    'type' => 'CATALOG_CONN_ITEM_VARIANT_IMPORT',
    'name' => 'bulk_import_123345677788999.csv',
    'locale' => 'en-US',
    'formatType' => 'jsonl'
  ]),
  CURLOPT_HTTPHEADER => [
    "Authorization: Bearer <token>",
    "Content-Type: application/json",
    "x-fabric-tenant-id: <x-fabric-tenant-id>"
  ],
]);

$response = curl_exec($curl);
$err = curl_error($curl);

curl_close($curl);

if ($err) {
  echo "cURL Error #:" . $err;
} else {
  echo $response;
}

Go

package main

import (
    "fmt"
    "strings"
    "net/http"
    "io"
)

func main() {

url := "https://api.fabric.inc/v3/catalog-connector-files"

payload := strings.NewReader("{\n  \"type\": \"CATALOG_CONN_ITEM_VARIANT_IMPORT\",\n  \"name\": \"bulk_import_123345677788999.csv\",\n  \"locale\": \"en-US\",\n  \"formatType\": \"jsonl\"\n}")

req, _ := http.NewRequest("POST", url, payload)

req.Header.Add("x-fabric-tenant-id", "<x-fabric-tenant-id>")
    req.Header.Add("Authorization", "Bearer <token>")
    req.Header.Add("Content-Type", "application/json")

res, _ := http.DefaultClient.Do(req)

defer res.Body.Close()
    body, _ := io.ReadAll(res.Body)

fmt.Println(string(body))
}

Response Example

{
  "id": "857f1f77bcf86cd799439054",
  "type": "CATALOG_CONN_ITEM_VARIANT_IMPORT",
  "name": "bulk_import_123345677788999.csv",
  "locale": "en-US",
  "formatType": "jsonl",
  "createdAt": "2021-09-14T22:10:30.618Z",
  "updatedBy": "test@email.com",
  "updatedAt": "2021-09-14T22:10:30.618Z",
  "location": "https://s3.console.aws.amazon.com/s3/buckets/greatwall-stg01-bulk-import-pim/bulk_import_123345677788999.csv"
}

Error Responses

400 Bad Request

{
  "message": "Request is invalid",
  "type": "Bad request",
  "errors": [
    {
      "type": "CLIENT_ERROR",
      "message": "Invalid request. Unable to find/create product"
    }
  ]
}

401 Unauthorized

{
  "type": "UNAUTHORIZED_ERROR",
  "message": "Requester is unauthorized"
}

403 Forbidden

{
  "type": "REQUEST_DENIED",
  "message": "User does not have the required permission"
}

500 Internal Server Error

{
  "type": "SERVER_ERROR",
  "message": "Internal Server Error"
}

Required Headers